Request

Response

    Project Bid Forms
    POST

    project-bid-forms

    Creates a project bid form for the specified BuildingConnected project.

    There can be only one project bid form per project.

    Resource Information

    Method and URI
    POST
    https://developer.api.autodesk.com/construction/buildingconnected/v2/project-bid-forms
    Authentication Context
    User context required
    Required OAuth Scopes
    data:write
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is a three-legged access token obtained via an Authorization Code flow.
    Content-Type*
    string
    Must be application/json
    * Required

    Request

    Body Structure

    Expand all
    projectId*
    string
    The ID of the BuildingConnected project that the bid form addresses.

    Max length: 24

    includeSectionHeaders
    boolean
    If true, any line items with a null description and a non-empty section will be treated as a section header.

    This is the only way to create section headers which don’t have any line items belonging to the section.

    Also, the response will include all of the section headers of the newly created bid form as line items with a null description and the section name in the section field.

    lineItems
    array: object
    An array of bid form line items.

    Note that each bid form line item must have a unique combination of type, description, and section values.

    Max 2000 bid form line items at bid form creation.

    type*
    enum:string
    The type of the bid form line item.

    The possible values have the following UI equivalents:

    • ACKNOWLEDGMENT — General Acknowledgments
    • BONDING — Bond Information
    • CERTIFICATION — Certifications
    • DISCLAIMER — Disclaimers and Clarifications
    • LABOR_RATE — Labor Rates
    • MARKUP — Fees and Markups
    description*
    string
    A description of the bid form line item.
    section
    string
    The user-defined name of an optional section of the bid form that the line item is in. If the section does not exist, a new section is created automatically. This value should be null if the item is not in a section.

    Note that all of the line items for which you provide the same section value will be in the same section.

    isRequired
    boolean
    Indicates whether the bid form line item is required. Possible values:
    • true: The bid form line item is required.
    • false: The bid form line item is optional.
    unit
    enum:string
    The unit format of the bid form line item.

    The possible values of this field depend on the value of the line item’s type field. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TEXT, PERCENTAGE, TOTAL_COST_ONLY
    • BONDING — YES_NO, TEXT, PERCENTAGE, TOTAL_COST_ONLY
    • CERTIFICATION — YES_NO, TEXT
    • DISCLAIMER — Converted to null
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    The cost code associated with the project line item.

    Max length: 87

    external
    object
    Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.

    Note that BuildingConnected does not use the information in this object.

    id*
    string
    A user-provided ID of the external tool.
    name
    string
    A user-provided name for the external tool.
    * Required

    Response

    HTTP Status Code Summary

    201
    Created
    Created
    400
    Bad Request
    The parameters of the requested operation are invalid.
    401
    Unauthorized
    The provided bearer token is not valid.
    403
    Forbidden
    The user or service represented by the bearer token does not have permission to perform this operation.
    404
    Not Found
    The requested resource could not be found.
    409
    Conflict
    A project bid form is already associated to the project.
    429
    Too Many Requests
    Rate limit exceeded; wait some time before retrying. The ‘Retry-After’ header might provide the amount of the time to wait.
    500
    Internal Server Error
    An unknown error occurred on the server.

    Response

    Header (201)

    Location
    string
    The created resource’s location.

    Response

    Body Structure (201)

    Expand all
    id
    string
    The ID of the BuildingConnected project bid form.

    Max length: 24

    projectId
    string
    The ID of the BuildingConnected project that the bid form addresses.

    Max length: 24

    currentAccLinkedProjectId
    string
    The ID of an ACC project linked with this bid form’s project.
    createdBy
    string
    The BuildingConnected ID of the user who created the project bid form.

    Max length: 24

    updatedBy
    string
    The BuildingConnected ID of the user who last updated the project bid form.

    Max length: 24

    createdAt
    datetime: ISO 8601
    The date and time that the project form was created, in ISO 8601 format.
    updatedAt
    datetime: ISO 8601
    The date and time that the project form was last updated, in ISO 8601 format.
    isTemplate
    boolean
    Indicates whether this bid form a is a template or an actual project bid form.
    • true: This bid form is a template.
    • false: This bid form belongs to an actual project.
    lineItems
    object
    A paginated list of the bid form’s line items.

    Max 100 line items per page.

    pagination
    object
    The pagination details of a response.
    limit
    int
    The maximum number of records to return per page.

    Note that a returned page may contain fewer records than the limit under either of these conditions:

    • There are fewer records found than the limit value.
    • The last or only page is returned.
    cursorState
    string
    An opaque cursor token that identifies where the next page of paginated results should start. It’s returned in each paginated response so that it can be provided in the next request to continue paginated results. If a paginated response contains no cursorState value, there are no further pages to return.

    Omit this parameter to initiate a paginated request or to restart pagination.

    nextUrl
    string
    The URL path that returns the next page of data.
    results
    array: object
    The array of bid form line items
    id
    string
    The unique ID of the bid form line item.

    Max length: 24

    type
    enum:string
    The type of the bid form line item.

    The possible values have the following UI equivalents:

    • ACKNOWLEDGMENT — General Acknowledgments
    • BONDING — Bond Information
    • CERTIFICATION — Certifications
    • DISCLAIMER — Disclaimers and Clarifications
    • LABOR_RATE — Labor Rates
    • MARKUP — Fees and Markups
    description
    string
    A description of the bid form line item.
    section
    string
    The user-defined name of a section of the bid form that the line item is in. This value is null if the item is not in a section.
    isRequired
    boolean
    Indicates whether the bid form line item is required. Possible values:
    • true: The bid form line item is required.
    • false: The bid form line item is optional.
    unit
    enum:string
    The unit format of the bid form line item.

    The possible values of this field depend on the value of the line item’s type field. Each possible line item type is listed, followed by the possible values of unit for that type:

    • ACKNOWLEDGMENT — YES_NO, TEXT, PERCENTAGE, TOTAL_COST_ONLY
    • BONDING — YES_NO, TEXT, PERCENTAGE, TOTAL_COST_ONLY
    • CERTIFICATION — YES_NO, TEXT
    • DISCLAIMER — Converted to null
    • LABOR_RATE — PER_HOUR, PER_DAY, PER_WEEK
    • MARKUP — PERCENTAGE, TOTAL_COST_ONLY

    Note that the value TOTAL_COST_ONLY is used for a lump sum line item.

    code
    string
    The cost code associated with the project line item.
    external
    object
    Information about an external tool that can link the line item to a cost or other element that is external to BuildingConnected.

    Note that BuildingConnected does not use information in this object.

    id
    string
    The ID of the external tool.
    name
    string
    The name of the external tool.

    Example

    Created

    Request

    curl -v 'https://developer.api.autodesk.com/construction/buildingconnected/v2/project-bid-forms' \
      -X 'POST' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Content-Type: application/json' \
      -d '{
            "projectId": "59d2bd7440b36a0da258f24d",
            "includeSectionHeaders": "",
            "lineItems": [
              {
                "type": "ACKNOWLEDGMENT",
                "description": "This line item is important.",
                "section": null,
                "isRequired": true,
                "unit": "YES_NO",
                "code": "D2",
                "external": {
                  "id": "ext-cost-id-123",
                  "name": "External Cost Code"
                }
              }
            ]
          }'
    
    Show More

    Response

    {
      "id": "5af0892518d349f6d59e1bbb",
      "projectId": "59d2bd7440b36a0da258f24d",
      "currentAccLinkedProjectId": "00f1b796-293a-4c1e-9474-f09711011426",
      "createdBy": "5542856b27aae240452fce62",
      "updatedBy": "5542856b27aae240452fce62",
      "createdAt": "2021-08-19T23:07:16.083Z",
      "updatedAt": "2021-08-20T23:07:16.083Z",
      "isTemplate": false,
      "lineItems": {
        "pagination": {
          "limit": 100,
          "cursorState": "eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9",
          "nextUrl": "https://developer.api.autodesk.com/construction/buildingconnected/v2/projects?cursorState=eyJsaW1pdCI6MjUsIm9mZnNldCI6MjV9"
        },
        "results": [
          {
            "id": "53811754d3a604966df72247",
            "type": "ACKNOWLEDGMENT",
            "description": "This line item is important.",
            "section": null,
            "isRequired": true,
            "unit": "YES_NO",
            "code": "D2",
            "external": {
              "id": "ext-cost-id-123",
              "name": "External Cost Code"
            }
          }
        ]
      }
    }
    
    Show More